"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createDocumentsAction = exports.createDocumentAction = void 0;
var _fetch = require("../fetch");
var _excluded = ["fetch", "handleFetch", "handleFetchSuccess", "handleFetchFailure", "token"];
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
var defaultHandleFetch = function defaultHandleFetch(c) {
  return {
    type: c.FETCH
  };
};
var defaultHandleSuccess = function defaultHandleSuccess(c, data) {
  return {
    type: c.FETCH_SUCCESS,
    payload: {
      data: data
    }
  };
};
var defaultHandleFailure = function defaultHandleFailure(c, error) {
  return {
    type: c.FETCH_FAILURE,
    payload: {
      error: error
    }
  };
};
var createDocumentsAction = exports.createDocumentsAction = function createDocumentsAction(namespace) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return function (dispatch, getState) {
    var c = {
      FETCH: "".concat(namespace, "/FETCH"),
      FETCH_SUCCESS: "".concat(namespace, "/FETCH_SUCCESS"),
      FETCH_FAILURE: "".concat(namespace, "/FETCH_FAILURE")
    };
    var _options$fetch = options.fetch,
      fetch = _options$fetch === void 0 ? _fetch.fetchDocuments : _options$fetch,
      _options$handleFetch = options.handleFetch,
      handleFetch = _options$handleFetch === void 0 ? defaultHandleFetch : _options$handleFetch,
      _options$handleFetchS = options.handleFetchSuccess,
      handleFetchSuccess = _options$handleFetchS === void 0 ? defaultHandleSuccess : _options$handleFetchS,
      _options$handleFetchF = options.handleFetchFailure,
      handleFetchFailure = _options$handleFetchF === void 0 ? defaultHandleFailure : _options$handleFetchF,
      token = options.token,
      params = _objectWithoutProperties(options, _excluded);
    dispatch(handleFetch(c));
    return fetch(_objectSpread(_objectSpread({}, params), {}, {
      token: getApiToken(token, getState())
    })).then(function (data) {
      dispatch(handleFetchSuccess(c, data));
      return Promise.resolve(data);
    })["catch"](function (error) {
      dispatch(handleFetchFailure(c, error));
      return Promise.reject(error);
    });
  };
};
var createDocumentAction = exports.createDocumentAction = function createDocumentAction(namespace, options) {
  return createDocumentsAction(namespace, _objectSpread(_objectSpread({}, options), {}, {
    fetch: _fetch.fetchDocument
  }));
};
var getApiToken = function getApiToken(token, state) {
  switch (_typeof(token)) {
    case 'function':
      return token(state);
    default:
      return token;
  }
};