"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createDocumentsReducer = exports.createDocumentReducer = void 0;
var _deserialize = _interopRequireDefault(require("../deserialize"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
var defaultHandleFetch = function defaultHandleFetch(state) {
  return _objectSpread(_objectSpread({}, state), {}, {
    status: 'fetching'
  });
};
var defaultHandleFailure = function defaultHandleFailure(state) {
  return _objectSpread(_objectSpread({}, state), {}, {
    status: 'failed'
  });
};
var defaultHandleSuccess = function defaultHandleSuccess(state, _ref) {
  var data = _ref.data;
  return _objectSpread(_objectSpread({}, state), {}, {
    status: 'fetched',
    data: (0, _deserialize["default"])(data)
  });
};
var defaultHandleMultipleSuccess = function defaultHandleMultipleSuccess(state, _ref2) {
  var _ref2$data = _ref2.data,
    data = _ref2$data === void 0 ? [] : _ref2$data;
  return _objectSpread(_objectSpread({}, state), {}, {
    status: 'fetched',
    data: data.map(function (doc) {
      return (0, _deserialize["default"])(doc);
    })
  });
};
var createDocumentReducer = exports.createDocumentReducer = function createDocumentReducer(namespace) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var _options$fetch = options.fetch,
    fetch = _options$fetch === void 0 ? defaultHandleFetch : _options$fetch,
    _options$fetchFailure = options.fetchFailure,
    fetchFailure = _options$fetchFailure === void 0 ? defaultHandleFailure : _options$fetchFailure,
    _options$fetchSuccess = options.fetchSuccess,
    fetchSuccess = _options$fetchSuccess === void 0 ? defaultHandleSuccess : _options$fetchSuccess,
    _options$initialState = options.initialState,
    initialState = _options$initialState === void 0 ? {} : _options$initialState;
  var c = {
    FETCH: "".concat(namespace, "/FETCH"),
    FETCH_SUCCESS: "".concat(namespace, "/FETCH_SUCCESS"),
    FETCH_FAILURE: "".concat(namespace, "/FETCH_FAILURE")
  };
  var handlers = _defineProperty(_defineProperty(_defineProperty({}, c.FETCH, fetch), c.FETCH_FAILURE, fetchFailure), c.FETCH_SUCCESS, fetchSuccess);
  return function () {
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
    var _ref3 = arguments.length > 1 ? arguments[1] : undefined,
      type = _ref3.type,
      payload = _ref3.payload;
    var handler = handlers[type];
    return typeof handler === 'function' ? handler(state, payload) : state;
  };
};
var createDocumentsReducer = exports.createDocumentsReducer = function createDocumentsReducer(namespace) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return createDocumentReducer(namespace, _objectSpread({
    fetchSuccess: defaultHandleMultipleSuccess
  }, options));
};